<?php

class Data {

/** Все возвращаемые данные обрабатываются функцией def_e 
* (эскэйпятся HTML-тэги и кавычки). Это не идеально.
* Надо будет добавить параметр (тип вызывающего view),
* определяющий, надо ли использовать def_e
*/
	
	protected $fields;
	protected $data;
	protected $subj;
	protected $id;
	protected $view;
	
	public function __construct($subj, $id = null, $view = null) {
		
		global $def;
		$this->fields = $def['fields'];
		
		if (!$subj) $subj = esse($def, 'subj');
		if (!$id) $id = esse($def, 'id');
		$this->subj = $subj;
		$this->id = $id;
		if (!$view) $view = ($this->id) ? 'item' : 'table';
		$this->view = $view;
		
		$this->data = array(
			'people' => array(
				1 => array('id' => 1, 'name' => "Александр", 'year' => "1985", 'descr' => "Лучший друг", 'email' => "alex@mail.com", 'rel' => "friends"),
				2 => array('id' => 2, 'name' => "Юрий", 'year' => "1987", 'descr' => "Друг средней степени", 'email' => "yury@gmail.com", 'rel' => "friends"),
				3 => array('id' => 3, 'name' => "Алексей", 'year' => "1989", 'descr' => "Очень сомнительный друг: может занять максимум 2-3 тысячи р.", 'email' => "alexey@yahoo.com", 'rel' => "friends"),
				4 => array('id' => 4, 'name' => "Джо", 'year' => "1909", 'descr' => "Somebody", 'email' => "joe@yahoo.com", 'rel' => "enemies"),
				5 => array('id' => 5, 'name' => "Джесси", 'year' => "1919", 'descr' => "Ведьма", 'email' => "jessie@yahoo.com", 'rel' => "enemies"),
			),
			'cats' => array(
				1 => array('id' => 1, 'name' => "Вася", 'year' => "1993", 'descr' => "Очень лохматый и чёрный"),
			),
			'Admin' => array(
				1 => array('id' => 1, 'name' => 'Установить БД', 'func' => 'install_bd', 'descr' => 'Существующие таблицы не будут перезаписаны'),
				2 => array('id' => 2, 'name' => 'Переустановить БД', 'func' => 'reinstall_bd', 'descr' => 'Существующие таблицы сначала будут уничтожены'),
			),
			'jobs' => array(
			),
		);
		
		$this->data = $this->set_data();
		
	}
	
	public function get() {
		$method = 'get_' . $this->view; 
		$data = $this->$method();
		$arr = array(
			'menu' => $this->get_menu(),
			'data' => $data
		);
		
		return $arr;
	}
	
	public function get_form_ini() {
		return $this->data;
	}
	
	public function get_sql($table, $where = array()) {
		global $def;
		$table = $def['mysql']['table_prefix'] . $table;

		return Mysql::get($table, $where);
	}
	
	public function set_data() {
		
		global $def;
		$meta = $def['meta'][$this->subj];
		$table = $meta['table'];
		$def['sql_table'] = $table;
		
		$key_source = array();
		$where = array();
		$type = esse($meta, 'type');
		$flag = esse($meta, 'flag');
		$flag_value = $this->subj;
		
		if ($type == 'file') return self::get_file($meta['table']);
		else if ($type == 'file_ini') return self::get_file_ini($meta['table']);
		else if ($type == 'Mysql') {
			if ($flag) $key_source[$flag] = $flag_value;
			$key_source += $_GET;
			$where = $this->get_key ($this->subj, $key_source);
			return $this->get_sql($table, $where); 
		}
		else { //php demo data => to remove
			$table = $this->data[$table];
			
			$id = $this->id;
			if ($flag) $where[$flag] = $flag_value;
			if (!empty($id) || 0 === $id) $where['id'] = $id;
			if (!isset($where[$flag]) && !isset($where['id'])) return $table;
			
			$arr = array();
			foreach ($table as $key => $row) {
				if (isset($where[$flag]) && $row[$flag] != $flag_value) continue;
				if (isset($where['id']) && $row['id'] != $id) continue;
				$arr[$key] = $row;
			}
			
			return $arr;
		}
	}
	
	private function get_key ($subj, &$arr) {
		global $def;
		$where = array();
		$fields = $def['fields'][$def['meta'][$subj]['table']];
		
		foreach ($fields as $key => $value) {
			$pk = intval(esse($value, 'key'));
			if ($pk > 1 && array_key_exists($key, $arr)) $where[$key] = $arr[$key];
		}
		
		return $where;
	}
	
	public function get_raw() {
		return $this->data;
	}
	
	public function get_item() {
		global $def;
		$table = $def['sql_table'];
		$meta = $def['meta'][$this->subj];
		
		$fields = $def['fields'][$table];
		$data = each($this->data);
		$data = $data['value'];
		
		
		return $this->get_row($fields, $data);
	}
	
	public function get_table() {
		global $def;
		$table = $def['sql_table'];
		$meta = $def['meta'][$this->subj];
		$title = $meta['title'];
		
		$fields = $this->fields[$table];
		$data = $this->data;
		$thead = array();
		$tbody = array();
		
		foreach ($fields as $field => $prop) {
			if (empty($prop['list'])) continue;
			$thead[$field] = $prop;
		}
		
		foreach ($data as $key => $value) {
			if ($key == 'item') continue; //нагородил!!
			$tbody[] = $this->get_row($thead, $value, $this->subj);
		}
		
		return array('caption' => $title, 'thead' => $thead, 'tbody' => $tbody, 'title' => $title);
	}
	
	private function build_get(&$arr){
		$str = '';
		foreach ($arr as $key => $value) {
			$str .= urlencode($key) . '=' . urlencode($value) . '&';
		}
		return $str;
	}
	
	private function get_row(&$arr, &$data, $subj = false) { //нижний / уровень : def_e!!
		$row = array();
		
		foreach ($arr as $field => $prop) {
			if (!empty($prop['ru'])) {
				$extra = ($subj) ? false : $prop['ru'];
				$tpl = false;
				$link = esse($prop, 'link');
				if ($link && $subj) {
					if ($link == 2) { //а что ещё там может быть?.. (2 - primary key)
						$pk = $this->get_key($subj, $data);
						$extra = urlencode($subj) . '?' . $this->build_get($pk);
					}
					$tpl = 'a';
				}
				$row[$field] = array(def_e($data[$field]), $extra, $tpl);
			}
		}
		
		return $row;
	}
	
	public function get_menu() { //нижний / уровень : def_e!!
		global $def; 
		$meta = $def['meta'];
		
		$menu = array();
		foreach ($meta as $subj => $arr) {
			$file = $subj . $def['ext'];
			if ($file == $def['file']) $file = false;
			
			if ($arr['menu']) //произвольно: отображать в меню
				$menu[] = array('href' => urlencode($file), 'text' => def_e($arr['title']));
		}
		
		return $menu;
	}
	
	public static function write($subj) {
		global $def;
		
		if (!esse($def, 'user', 'status') && $def['env']['server_ip'] != $def['env']['klient_ip'])
			return 'not enough rights';
		
		$type = esse($def['meta'], $subj, 'type');
		$method = 'write_' . $type;
		self::check_gpc($_POST);
		return (!isset($_POST['set'])) 
			? '!POST[set]' 
			: self::$method($subj, $_POST['set']);
	}
	
	public static function write_file_ini($subj, &$arr) {
		global $def;
		$f = esse($def['meta'], $subj, 'table');
		$str = '';
		foreach ($arr as $sect => $props) {
			$str .= '[' . $sect . ']' . CR;
			foreach ($props as $key => $value) {
				$str .= $key . '="' . addcslashes($value, '"') . '"' . CR;
			}
		}
		file_put_contents($f, $str);
		return 0;
	}
	
	public static function get_file_ini($f) {
		global $def;
		return (isset($f) && file_exists($f)) ? parse_ini_file($f, true) : array();
	}
	
	public static function get_file($f) {
		return (file_exists($f)) ? def_e(implode(file($f))) : '';
	}
	
	public static function check_gpc(&$arr) {
		if (!get_magic_quotes_gpc() && !get_magic_quotes_runtime()) return false;
		foreach($arr as $key => $value) {
			if (is_array($value)) check_gpc($arr[$key]);
			else $arr[$key] = stripslashes($value);
		}
	}

}
