<?php

class Mysql {
	
	private static $conn = array();
	
	public static function connect($dsn = array()) {
		global $def;
		if (!count($dsn)) $dsn = $def['mysql'];
		
		$user = esse($dsn, 'user');
		if (!$user) return null;
		$user = $dsn['bd_prefix'] . $user;
		if (!empty(self::$conn[$user])) return self::$conn[$user];
		
		$pw = esse($dsn, 'pw');
		$host = $dsn['host'];
		if (!empty($dsn['port']))  $host .= ':' . $dsn['port'];
		
		self::$conn[$user] = mysql_connect($host, $user, $pw);
		
		if (!empty($dsn['charset'])) {
			mysql_query('set names ' . $dsn['charset']);
		}

		if (!empty($dsn['bd'])) {
			$bd = $dsn['bd_prefix'] . $dsn['bd'];
			mysql_select_db($bd);
		}
		
		mysql_query("SET TIME_ZONE='+{$dsn['TZ_offset']}:00'");
		
		return self::$conn[$user];
	}
	
	public static function get($table, $where = '', $select = '*', $limit = 20) {
	    
	    $table = self::set_value($table, '`');
	    $select = self::build_select($select);
	    $where = self::build_where($where);
	    $limit = ' LIMIT ' . $limit;
	    $sql = $select . ' FROM ' . $table . $where . $limit;
	    
	    self::connect();
	    
	    return self::select_table($sql); 
	}

	public static function select_cell($sql, $skip_err = false) {
		$r = self::get_resource($sql, $skip_err);
		return ($r[1]) ? mysql_result($r[0], 0, 0) : null;
	}

	public static function select_row($sql, $skip_err = false){
		$r = self::get_resource($sql, $skip_err);
		return ($r[1]) ? mysql_fetch_assoc($r[0]) : null;
	}

	public static function select_col($sql, $skip_err = false) {
		$r = self::get_resource($sql, $skip_err);
		$arr = array();
		if (!$r[1]) return $arr;
		while ($row = mysql_fetch_row($r[0])) {
			$arr[] = $row[0];
		}
		return $arr;
	}

	public static function select_table($sql, $skip_err = false){
		$r = self::get_resource($sql, $skip_err);
		$t = array();
		if (!$r[1]) return $t;
		
		$j = 0;
		while ($row = mysql_fetch_assoc($r[0])) {
			$j ++;
			$t[$j] = array();
			foreach ($row as $key => $value) {
				$t[$j][$key] = $value;
			}
		}
		return $t;
	}

	private static function get_resource($sql, $skip_err = false) {
	    $r = mysql_query($sql);
	    $err = mysql_error();
	    if ($err) {
	        $n = false;
	        $err_vis = $sql . '; ERROR: ' . $err;
	        if (!$skip_err) exit(View::display_error($err_vis, true));
	        else $r = $err_vis;
	    }
	    else $n = (is_resource($r)) ? mysql_num_rows($r) : false;
	    return array($r, $n); 
	}

	private static function build_select($arr, $noslovo = false){
	    $selectstr = '';
	    $slovo = ($noslovo === false) ? 'SELECT ' : '';
	    if (!is_array($arr)) return $slovo . $arr;
		
	    $comma = '';
	    foreach($arr as $field) {
	        $field = mysql_escape_string($field);
	        $field = str_replace('.', '`.`', $field);
	        $selectstr .= "{$comma}`$field` ";
	        $comma = ', ';
	    }
		
	    $selectstr = ($selectstr) ? " {$slovo}$selectstr " : '';
	    return $selectstr;
	}

	private static function build_where($where, $nowhere = false){ 
	    $wherestr = '';
	    if (!is_array($where)) return $wherestr;
	    $comma = '';
	    foreach($where as $key => $val) {
	        if (is_array($val)) {
	            $value = (isset($val['value'])) ? $val['value'] : $val;
	            $case = (isset($val['case'])) ? self::set_value($val['case'], "") : '=';
	        }
	        else {
	            $value = $val;
	            $case = '=';
	        }
	        $value = self::set_value($value, "'");
	        $field = mysql_escape_string($key);
	        $field = str_replace('.', '`.`', $field);
	        $wherestr .= "{$comma}`$field` {$case} $value";
	        $comma = ' AND ';
	    }
	    $where_slovo = ($nowhere === false) ? ' WHERE ' : '';
	    $wherestr = ($wherestr) ? " {$where_slovo}($wherestr) " : '';
	    return $wherestr;
	}

	private static function set_value($val, $quot) {
	    $v = false;
	    if (is_array($val) && isset($val['func'])) {
	        $v = "{$val['func']}(";
	        $comma = '';
	        foreach($val['param'] as $p) {
	            $quot = (isset($p[1])) ? $p[1] : '';
	            $par = mysql_escape_string($p[0]);
	            $v .= "$comma{$quot}$par{$quot}";
	            $comma = ', ';
	        }
	        $v .= ")";
	    }
	    else {
	        $v = mysql_escape_string($val);
	        $v = "{$quot}$v{$quot}";
	    }
	    return $v;
	}
		

}