<?php

class View {
	
	protected $data;
	protected $subj;
	protected $id;
	protected $view;
	
	public function __construct($subj, $id, $view = null) {
		global $def;
		if (!$subj) $subj = esse($def, 'subj');
		if (!$id) $id = esse($def, 'id');
		$this->subj = $subj;
		$this->id = $id;
		if (!$view) $view = ($this->id) ? 'item' : 'table';
		$this->view = $view;
		$data = new Data($subj, $id, $view);
		
		$this->data = $data->get();
		$this->out();
	}
	
	public function out() {
		global $def;
		$meta = $def['meta'][$this->subj];
		$view = $this->view;
		$data = $this->data;
		
		
		$class = $meta['table'];
		$func = esse($data, 'data', 'func', 0);
		if ($func) $class = new $class;
		
		$arr = array();
		$arr['title'] = esse($meta, 'title');
		$source = esse($meta, 'type');
		if ($source) $arr['title'] .= ' (source: ' . $source . ')';
		
		$arr['menu'] = $this->build_menu($data['menu']);
		$arr['body'] = (empty($func)) ? $this->tpl($view) : ($class->$func());
		
		$add = esse($meta, 'add');
		if ($add && !$func) {
			foreach ($add as $essence) {
				$c_view = esse($def['meta'], $essence, 'view');
				$c_data = new Data($essence, null, $c_view);
				$c_data = $c_data->get();
				$str = $this->tpl_raw($c_view, $c_data);
				$arr['body'] .= $str;
			}
		}
				
		$arr['footer'] = ($def['id']) ? '' : <<<TPL
	<div class='distr'>
	<h4><a href='./repa/'>дистрибутивы</a> маленького фреймворка (версии)</h4>
	<p><a href='http://ir2.ru/quiproquo.aspx'>Что из чего следует во фреймворке «Friends»</a> (общая схема, 29.10.11)</p>
	<p><a href='http://ir2.ru/php_framework.aspx'>php-фреймворк анти-MVC-ООП</a>, описание (17.10.11)</p>
	</div>
TPL;
		
		print $this->tpl_page($arr);
	}
	
	private function tpl($view, $data = null){
		$method = 'tpl_' . $view;
		return $this->$method($view, $data);
	}
	
	public static function write($subj) {
		global $def;
		$err = Data::write($subj);
		if (!$err) header('Location: ' . $def['env']['referer']);
		else self::print_error($err);
	}
	
	public static function print_error($err) {
		echo '<center style="width:40em;"><br><br><br>' . $err . '</center>';
	}
	
	private function tpl_form_ini($view, $data) {
		if (empty($data)) $data = $this->data['data'];
		
		$str = '<form action="write.com" method="post">' . CR;
		
		foreach ($data as $sect => $props) {
			if (!is_array($props)) continue; //выкидываем параметры вне секций на
			$str .= '<div>' . sprintf(self::htpl(2, 'h3'), $sect);
			foreach ($props as $key => $value) {
				$str .= $this->tpl_input('set[' . $sect . ']' . '[' . $key . ']', $value, 'text', $key) . CR;
			}
			$str .= '</div>' . CR;
		}
		$str .= $this->tpl_input('subj', $this->subj, 'hidden', '', '') . CR;
		$str .= '<br>' . $this->tpl_input('go', 'Сохранить', 'submit', '', '') . CR;
		$str .= '</form>' . CR;
		return $str;
	}
	
	private function tpl_input($key, $value, $type = 'text', $view_name, $key_tag = 'span', $row_tag = 'p') {
		if (!isset($view_name)) $view_name = $key;
		$str = '';
		if ($key_tag) $str .= sprintf(self::htpl(2, $key_tag), $view_name . ': ');
		$str .= sprintf(self::htpl(1, 'input', 'name', 'value', 'type'), $key, $value, $type);
		return sprintf(self::htpl(2, $row_tag), $str);
	}
	
	private function tpl_raw($view, $data) {
		if (empty($data)) $data = $this->data;
		$str = $data['data'];
		return sprintf(self::htpl(2, 'pre'), $str);
	}
	
	private function build_menu() {
		$menu = $this->data['menu'];
		$out = array();
		foreach($menu as $arr) {
			$out[] = (!empty($arr['href'])) 
				? sprintf(self::htpl(2, 'a', 'href'), $arr['text'], $arr['href'])
				: sprintf(self::htpl(2, 'span'), $arr['text']);
		}
		return implode(' | ', $out);
	}
		
	private function tpl_page(&$arr) {
		global $def;
		
		//перекрытие
		$default = array(
			'doctype' => esse($def, 'page', 'doctype'),
			'metas' => esse($def, 'page', 'metas'),
			'styles' => esse($def, 'page', 'styles'),
			'scripts' => esse($def, 'page', 'scripts'),
			'title' => esse($arr, 'title'),
			'body_attrs' => esse($arr, 'body_attrs'),
			'header' => esse($arr, 'header'),
			'menu' => esse($arr, 'menu'),
			'body' => esse($arr, 'body'),
			'footer' => esse($arr, 'footer'),
		);
		if (empty($default['title'])) $default['title'] = $def['site']['title'];
		//вот и весь "интерфейс"!
		
		extract($default);
		return <<<TPL
{$doctype}
<head>
	{$metas}
	<title>{$title}</title>
	{$styles}
	{$scripts}
</head>
<body{$body_attrs}>
	{$header}
	<div class="menutop">{$menu}</div>	
	{$body}
	{$footer}
</body>

TPL;
	} //function tpl_page
	
	//subclass Table
	
	private function tpl_table($view) {
		global $def;
		
		$caption = $this->data['data']['caption'];
		$head = $this->build_head($view);
		$thead = $head['thead'];
		$cols = $head['cols'];
		$tbody = $this->build_tbody($view);

		return <<<TPL
<table class="{$def['sql_table']}">
	<caption>{$caption}</caption>
	<colgroup>{$cols}</colgroup>
	<thead>{$thead}</thead>
	<tbody>{$tbody}</tbody>
</table>
TPL;
	}
	
	private function build_head($view) {
		global $def;
		
		$head = $this->data['data']['thead'];
		
		$thead = '<tr>';
		$cols = '';
		foreach($head as $field => $prop) {
			if (!empty($prop[$def['show']])) {
				$thead .= sprintf(self::htpl(2, 'th', 'class'), $prop[$def['show']], $field);
				$cols .= sprintf(self::htpl(1, 'col', 'class'), $field);
			}
		}
		$thead .= '</tr>';
		return array('thead' => $thead, 'cols' => $cols);
	}
	
	private function build_tbody($view) {
		global $def;
		
		$thead = $this->data['data']['thead'];
		$tbody = $this->data['data']['tbody'];
		$str = '';
		
		foreach($tbody as $row) {
			
			$str .= '<tr>';
			foreach($thead as $field => $prop) {
				if (!empty($prop[$def['show']])) {
					$value = $row[$field];
					$html = (!empty($value[2])) 
					? sprintf(self::htpl(2, $value[2]), $value[0], $value[1]) 
					: $value[0];
					
					$str .= sprintf(self::htpl(2, 'td'), $html);
				}
			}
			$str .= '</tr>';
		}
		
		return $str;
	
	} //subclass Table
	
	//subclass Item
	
	private function tpl_item($view) {
		$item = $this->build_item($view);
		return <<<TPL
<div class="item">
	
	{$item}
</div>
TPL;
	}
	
	private function build_item($view) {
		global $def;
		
		$item = $this->data['data']; 
		$str = '';
		$alt = '';
		foreach($item as $name => $it) {
			if (!$alt) $alt = $it[0]; //тупо (не знаю, как обратиться к первому элементу ассоц. массива)
			$html = sprintf(self::htpl(2, 'strong'), $it[1]) . ': ' . $it[0];
			$str .= sprintf(self::htpl(2, 'p'), $html);
		}
		$img = 'img/' . $def['id'] . '.gif';
		
		if (file_exists($def['site_path'] . '/' . $img))
			$str .= sprintf(self::htpl(1, 'img'), $img, $alt);
		
		return $str;
	} //subclass Item
	
	public static function display_error($s) {
		return sprintf(self::htpl(2, 'div', 'style'), $s, 'margin:5em auto; width:40em; text-align:left; padding:1em; border:2px solid red;');
	}
	
	public static function htpl() {
		$def = array(
			'img' => array('src', 'alt'),
			'a' => array('href'),
		);
		
		$args = func_get_args();
		if (is_array($args[0])) $args = $args[0];
		$mode = intval(array_shift($args));
		$tag = array_shift($args);
		if (!count($args)) $args = esse($def, $tag);
		if (!$args) $args = array();
		$attrs = '';
		
		foreach ($args as $key => $attr) $attrs .= ' ' . $attr . '="%' . ($key + $mode) . "\$s\" ";
		
		return ($mode == 1) ? '<' . $tag . $attrs . ' />' 
			: '<' . $tag . $attrs . ">%1\$s</" . $tag . '>';
		
	}
	
} //class View