/** При установке БД будут выполнены следующие mysql-запросы.
* Запросы будут модифицированы в зависимости от выбранных опций:
* если выбрана ПЕРЕустановка, будут добавлены запросы
* на удаление таблиц.
* Во всех случаях к именам таблиц будет добавлен префикс,
* указанный в настройке table_prefix= в файле site.ini.
*/

CREATE TABLE if not exists `msgs` (
  `id` int(11) NOT NULL auto_increment,
  `metka` tinyint(3) NOT NULL default '1',
  `name` varchar(30) NOT NULL default '',
  `email` varchar(100) default NULL,
  `msg` varchar(255) NOT NULL default '',
  `datrec` timestamp NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;


CREATE TABLE if not exists `users` (
  `name` varchar(10),
  `password` varchar(32),
  `fullname` varchar(30),
  `email` varchar(100),
  `status` tinyint(3),
  `time` timestamp NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

insert ignore into `users` (`name`, `password`, `fullname`, `email`, `status`) values 
('admin', old_password('admin'), 'Скабичевский', '@mail.ru', 2);

CREATE TABLE if not exists `people` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(30) NOT NULL,
  `year` varchar(25) NOT NULL,
  `email` varchar(100) NOT NULL,
  `descr` varchar(255) NOT NULL,
  `rel` varchar(25) NOT NULL,
  `time` timestamp NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`id`, `rel`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

CREATE TABLE if not exists `cats` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(30) NOT NULL,
  `year` varchar(25) NOT NULL,
  `descr` varchar(255) NOT NULL,
  `time` timestamp NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

CREATE TABLE if not exists `jobs` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(30) NOT NULL,
  `boss` varchar(30) NOT NULL,
  `agent` varchar(30) NOT NULL,
  `time1` DATETIME NOT NULL,
  `time2` DATETIME NOT NULL,
  `descr` varchar(255) NOT NULL,
  `time` timestamp NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;


insert ignore into `people` (`id`, `name`, `year`, `descr`, `email`, `rel`) values 
(1, 'Александр', '1985', 'Лучший друг', 'alex@mail.com', 'friends'),
(2, 'Юрий', '1987', 'Друг средней степени', 'yury@gmail.com', 'friends'),
(3, 'Алексей', '1989', 'Очень сомнительный друг: может занять максимум 2-3 тысячи р.', 'alexey@yahoo.com', 'friends'),
(4, 'Джо', '1909', 'Somebody', 'joe@yahoo.com', 'enemies'),
(5, 'Джесси', '1919', 'Ведьма', 'jessie@yahoo.com', 'enemies')
;

insert ignore into `cats` (`id`, `name`, `year`, `descr`) values 
(1, 'Вася', '1993', 'Очень лохматый и чёрный');
